<?php

namespace WP_SMS\Gateway;

class ippanel extends \WP_SMS\Gateway {
	private $domain = "ippanel.com";
	public $tariff = "http://ippanel.com/";
	public $unitrial = true;
	public $unit;
	public $flash = "diable";
	public $isflash = false;

	public function __construct() {
		parent::__construct();
		$this->validateNumber = "09xxxxxxxx";

		if ( class_exists( 'curl' ) ) {
			return new \WP_Error( 'Ippanel Gateway Error', 'You should enable CUrl to use this gateway.' );
		}
	add_action( 'wp_ajax_wp_sms_ippanel_CheckPattern', array( $this,'checkPattern') );
	add_action( 'wp_ajax_wp_sms_ippanel_test', array( $this,'sms_ippanel_test'));
	}

	public function SendSMS() {

		$this->from = apply_filters( 'wp_sms_from', $this->from );
		$this->to = apply_filters( 'wp_sms_to', $this->to );
		$this->msg = apply_filters( 'wp_sms_msg', $this->msg );

		$error = false;
		$response = false;
		$username = trim($this->username);
		$password = trim($this->password);
		$from     = trim($this->from);
		$domain   = trim($this->domain);
		if ( empty( $username ) || empty( $password ) || empty( $from ) ) {
			return new \WP_Error( 'Ippanel Gateway Error', 'تنظیمات درگاه به صورت کامل انجام نگرفته است.' );
		}
		$massage  = trim(strip_tags($this->msg));
		if(is_array($this->to)) $to = $this->to; else  $to = explode(',',$this->to);
		$massage = str_replace('pcode:','patterncode:',strip_tags(trim($massage)));
		if (substr( $massage, 0, 11 ) === "patterncode"){
			$massage = str_replace("\r\n",";",$massage);
			$massage = str_replace("\n",";",$massage);
			$splited = explode(';', $massage);
			$patterncodeArray = explode(':', $splited[0]);
			$patterncode = trim($patterncodeArray[1]);
			unset($splited[0]);

			$input_data = array();
			foreach($splited as $parm){
			  $splited_parm = explode(':', $parm, 2);
			  $input_data[$splited_parm[0]] = trim($splited_parm[1]);
			}
			foreach($to as $toNum){
				$url = "/patterns/pattern?username=".urlencode($username)."&password=".urlencode($password)."&from=$from&to=".json_encode(array($toNum))."&input_data=".urlencode(json_encode($input_data))."&pattern_code=".$patterncode;
				$result = $this->cUrl( $url, array(), 'GET' );
			}

			$resultarray = json_decode($result);
			if (is_array($resultarray) && $resultarray[0] != 'sent') {
				$res_code = $resultarray[0];
				$res_data = $resultarray[1];
				$error = $this->getErrors($res_code);
			}
			$response = $result;
		}else{
			$url = "/services.jspd";
			$params = array
						(
							'uname'=>$username,
							'pass'=>$password,
							'from'=>$from,
							'message'=>$massage,
							'to'=>json_encode($to),
							'op'=>'send'
						);
			$result = $this->cUrl( $url, $params, 'POST' );
			$result2 = json_decode($result);
			$res_code = $result2[0];
			$res_data = $result2[1];
			if ($res_code == '0'){
				
				$response = $res_data;
			}else{
				$error = $this->getErrors($res_code);
			}
		}

		if ( $error ) {

			// Log the result
			$this->log( $this->from, $this->msg, $this->to, $result, 'error' );
			return new \WP_Error( 'send_sms', $error );
		}
		// Log the result
		$this->log( $this->from, $this->msg, $this->to, $this->getErrors(0).$response );
		do_action( 'wp_sms_send', $result );

		return true;
	}

	public function GetCredit() {
		// Check username and password
		if ( ! $this->username && ! $this->password ) {
			return new \WP_Error( 'account-credit', __( 'Username/Password does not set for this gateway', 'wp-sms' ) );
		}

		$url = "/services.jspd";
		$params = array
					(
						'uname' => trim($this->username),
						'pass'  => trim($this->password),
						'op'    => 'credit'
					);
		$result = $this->cUrl( $url, $params, 'POST' );
		$response = json_decode($result);
		$res_code = $response[0];
		$res_data = $response[1];
		if ($res_code == '0'){
			return round($res_data).' ریال';
		}else{
			return $this->getErrors($res_code);
		}
	}

		
	public function checkPattern(){

		if(isset($_POST['patternCode'])){
			$params = array(
				'uname' => trim($this->username),
				'pass'  => trim($this->password),
				'patternCode'=> esc_html(trim($_POST['patternCode'])),
				'op'=> 'getPatternParams',
			);
			$url = "/api/select";
			$result = $this->cUrl( $url, json_encode($params), 'POST' );
			$response = json_decode($result,true);
			echo json_encode($response);
		}else{
			echo '-1';
		}
		wp_die();
	}
		
	public function sms_ippanel_test(){

		$this->to = explode(',',sanitize_text_field($_POST['phone']));
		$this->msg = $massage = str_replace('%','',strip_tags(trim($_POST['body'])));;
		$res = $this->SendSMS();

		if($res === true){
			print $res;
		}elseif(isset($res->errors['send_sms'])){
			print $res->errors['send_sms'][0];
		}else{
			print 'اشکال نامشخص.';
		}
		
		wp_die();
		
	}
	private function cUrl( $url, $params = array() , $method = 'POST' ) {
		$handler = curl_init($this->domain.$url);       	
		curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 5); 
		curl_setopt($handler, CURLOPT_TIMEOUT, 20);
		curl_setopt($handler, CURLOPT_CUSTOMREQUEST, $method);
		if($method == 'POST') curl_setopt($handler, CURLOPT_POSTFIELDS, $params);
		curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($handler);
		if (curl_errno($handler)) {
			$result = curl_error($handler);
			return json_encode(array('-10',$result));
		}
		return $result;
	}
	private function getErrors($error){
		$errorCodes = array(
			'-10'  => 'خطا در برقراری ارتباط با سامانه پیامک.',
			'-1'  => 'خطا در ارسال به شماره همراه. با پشتیبانی تماس بگیرید.',
			'0'  => 'با موفقیت به سامانه ارسال شد. کد پیامک: ',
			'1'  => 'متن پیام خالی می باشد.',
			'2'  => 'کاربر محدود گردیده است.',
			'3'  => 'خط به شما تعلق ندارد.',
			'4'  => 'گیرندگان خالی است.',
			'5'  => 'اعتبار کافی نیست.',
			'7'  => 'خط مورد نظر برای ارسال انبوه مناسب نمیباشد.',
			'9'  => 'خط مورد نظر در این ساعت امکان ارسال ندارد. برای ارسال پیامک در ۲۴ ساعت شبانه روز از وب سرویس پترن استفاده نمایید',
			'98' => 'حداکثر تعداد گیرنده رعایت نشدهه است.',
			'99' => 'اپراتور خط ارسالی قطع می باشد.',
			'21' => 'پسوند فایل صوتی نامعتبر است.',
			'22' => 'سایز فایل صوتی نامعتبر است.',
			'23' => 'تعداد تالش در پیام صوتی نامعتبر است.',
			'100' => 'شماره مخاطب دفترچه تلفن نامعتبر می باشد.',
			'101' => 'شماره مخاطب در دفترچه تلفن وجود دارد.',
			'102' => 'شماره مخاطب با موفقیت در دفترچه تلفن ذخیره گردید.',
			'111' => 'حداکثر تعداد گیرنده برای ارسال پیام صوتی رعایت نشده است.',
			'131' => 'تعداد تالش در پیام صوتی باید یکبار باشد.',
			'132' => 'آدرس فایل صوتی وارد نگردیده است.',
			'266' => 'ارسال با خط اشتراکی امکان پذیر نیست.',
			'301' => 'از حرف ویژه در نام کاربری استفاده گردیده است.',
			'302' => 'قیمت گذاری انجام نگریدهه است.',
			'303' => 'نام کاربری وارد نگردیده است.',
			'304' => 'نام کاربری قبال انتخاب گردیده است.',
			'305' => 'نام کاربری وارد نگردیده است.',
			'306' => 'کد ملی وارد نگردیده است.',
			'307' => 'کد ملی به خطا وارد شده است.',
			'308' => 'شماره شناسنامه نا معتبر است.',
			'309' => 'شماره شناسنامه وارد نگردیده است.',
			'310' => 'ایمیل کاربر وارد نگردیده است.',
			'311' => 'شماره تلفن وارد نگردیده است.',
			'312' => 'تلفن به درستی وارد نگردیده است.',
			'313' => 'آدرس شما وارد نگردیده است.',
			'314' => 'شماره موبایل را وارد نکرده اید.',
			'315' => 'شماره موبایل به نادرستی وارد گردیده است.',
			'316' => 'سطح دسترسی به نادرستی وارد گردیده است.',
			'317' => 'کلمه عبور وارد نگردیده است.',
			'455' => 'ارسال در آینده برای کد بالک ارسالی لغو شد.',
			'456' => 'کد بالک ارسالی نامعتبر است.',
			'458' => 'کد تیکت نامعتبر است.',
			'964' => 'شما دسترسی نمایندگی ندارید.',
			'962' => 'نام کاربری یا کلمه عبور نادرست می باشد.',
			'963' => 'دسترسی نامعتبر می باشد.',
			'971' => 'پترن ارسالی نامعتبر است.',
			'970' => 'پارامتر های ارسالی برای پترن نامعتبر است.',
			'972' => 'دریافت کننده برای ارسال پترن نامعتبر می باشد.',
			'992' => 'ارسال پیام از ساعت 8 تا 23 می باشد. برای ارسال پیامک در ۲۴ ساعت شبانه روز از وب سرویس پترن استفاده نمایید',
			'993' => 'دفترچه تلفن باید یک آرایه باشد',
			'994' => 'لطفا تصویری از کارت بانکی خود را از منو مدارک ارسال کنید',
			'995' => 'جهت ارسال با خطوط اشتراکی سامانه، لطفا شماره کارت بانکیه خود را به دلیل تکمیل فرایند  احراز هویت از بخش ارسال مدارک ثبت نمایید.',
			'996' => 'پترن فعال نیست.',
			'997' => 'شما اجازه ارسال از این پترن را ندارید.ه',
			'998' => 'کارت ملی یا کارت بانکی شما تایید نشده است.',
			'1001' => 'فرمت نام کاربری درست نمی باشد)حداقله ۵ کاراکتر، فقط حروف و اعداد(.',
			'1002' => 'گذر واژه خیلی ساده می باشد)حداقل ۸ کاراکتر بوده و نام کاربری،',
			'ایمی' => ' و شماره موبایل در آن وجود نداشته باشد(.',
			'1003' => 'مشکل در ثبت، با پشتیبانی تماس بگیرید.',
			'1004' => 'مشکل در ثبت، با پشتیبانی تماس بگیرید.',
			'1005' => 'مشکل در ثبت، با پشتیبانی تماس بگیرید.',
			'1006' => 'تاریخ ارسال پیام برای گذشته می باشد، لطفا تاریخ ارسال پیام را به درستی وارد نمایید.ه',
		);
		return (isset($errorCodes[$error])) ? $errorCodes[$error] : 'اشکال تعریف نشده با کد :' . $error;
	}
}